Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3019)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3036)
@@ -25,81 +25,93 @@
 ! -----------------
 ! $Id$
+! Revision of input vars according to UC2 data standard
+!  - renamed 'orography_2D' to 'zt'
+!  - renamed 'buildings_2D' to 'buildings_2d'
+!  - renamed 'buildings_3D' to 'buildings_3d'
+!  - renamed 'leaf_are_density' to 'lad'
+!  - renamed 'basal_are_density' to 'bad'
+!  - renamed 'root_are_density_lad' to 'root_area_dens_r'
+!  - renamed 'root_are_density_lsm' to 'root_area_dens_s'
+!  - renamed 'ls_forcing_ug' to 'tend_ug'
+!  - renamed 'ls_forcing_vg' to 'tend_vg'
+!
+! 3019 2018-05-13 07:05:43Z maronga
 ! Improved reading speed of large NetCDF files
-! 
+!
 ! 2963 2018-04-12 14:47:44Z suehring
 ! - Revise checks for static input variables.
-! - Introduce index for vegetation/wall, pavement/green-wall and water/window 
+! - Introduce index for vegetation/wall, pavement/green-wall and water/window
 !   surfaces, for clearer access of surface fraction, albedo, emissivity, etc. .
-! 
+!
 ! 2958 2018-04-11 15:38:13Z suehring
 ! Synchronize longitude and latitude between nested model domains, values are
 ! taken from the root model.
-! 
+!
 ! 2955 2018-04-09 15:14:01Z suehring
-! Extend checks for consistent setting of buildings, its ID and type. 
+! Extend checks for consistent setting of buildings, its ID and type.
 ! Add log-points to measure CPU time of NetCDF data input.
-! 
+!
 ! 2953 2018-04-09 11:26:02Z suehring
 ! Bugfix in checks for initialization data
-! 
+!
 ! 2947 2018-04-04 18:01:41Z suehring
 ! Checks for dynamic input revised
-! 
+!
 ! 2946 2018-04-04 17:01:23Z suehring
-! Bugfix for revision 2945, perform checks only if dynamic input file is 
+! Bugfix for revision 2945, perform checks only if dynamic input file is
 ! available.
-! 
+!
 ! 2945 2018-04-04 16:27:14Z suehring
-! - Mimic for topography input slightly revised, in order to enable consistency 
+! - Mimic for topography input slightly revised, in order to enable consistency
 !   checks
 ! - Add checks for dimensions in dynamic input file and move already existing
-!   checks 
-! 
+!   checks
+!
 ! 2938 2018-03-27 15:52:42Z suehring
-! Initial read of geostrophic wind components from dynamic driver. 
-! 
+! Initial read of geostrophic wind components from dynamic driver.
+!
 ! 2773 2018-01-30 14:12:54Z suehring
 ! Revise checks for surface_fraction.
-! 
+!
 ! 2925 2018-03-23 14:54:11Z suehring
-! Check for further inconsistent settings of surface_fractions. 
+! Check for further inconsistent settings of surface_fractions.
 ! Some messages slightly rephrased and error numbers renamed.
-! 
+!
 ! 2898 2018-03-15 13:03:01Z suehring
-! Check if each building has a type. Further, check if dimensions in static 
-! input file match the model dimensions. 
-! 
+! Check if each building has a type. Further, check if dimensions in static
+! input file match the model dimensions.
+!
 ! 2897 2018-03-15 11:47:16Z suehring
 ! Relax restrictions for topography input, terrain and building heights can be
-! input separately and are not mandatory any more. 
-! 
+! input separately and are not mandatory any more.
+!
 ! 2874 2018-03-13 10:55:42Z knoop
 ! Bugfix: wrong placement of netcdf cpp-macros fixed
-! 
+!
 ! 2794 2018-02-07 14:09:43Z knoop
 ! Check if 3D building input is consistent to numeric grid.
-! 
+!
 ! 2773 2018-01-30 14:12:54Z suehring
 ! - Enable initialization with 3D topography.
 ! - Move check for correct initialization in nesting mode to check_parameters.
-! 
+!
 ! 2772 2018-01-29 13:10:35Z suehring
 ! Initialization of simulation independent on land-surface model.
-! 
+!
 ! 2746 2018-01-15 12:06:04Z suehring
 ! Read plant-canopy variables independently on land-surface model usage
-! 
+!
 ! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
-! 
+!
 ! 2711 2017-12-20 17:04:49Z suehring
-! Rename subroutine close_file to avoid double-naming.  
-! 
+! Rename subroutine close_file to avoid double-naming.
+!
 ! 2700 2017-12-15 14:12:35Z suehring
 !
 ! 2696 2017-12-14 17:12:51Z kanani
 ! Initial revision (suehring)
-! 
-! 
+!
+!
 !
 !
@@ -107,9 +119,9 @@
 ! --------
 ! @author Matthias Suehring
-! 
+!
 ! Description:
 ! ------------
-!> Modulue contains routines to input data according to Palm input data       
-!> standart using dynamic and static input files. 
+!> Modulue contains routines to input data according to Palm input data
+!> standart using dynamic and static input files.
 !>
 !> @todo - Order input alphabetically
@@ -120,5 +132,5 @@
 !------------------------------------------------------------------------------!
  MODULE netcdf_data_input_mod
- 
+
     USE control_parameters,                                                    &
         ONLY:  coupling_char, io_blocks, io_group
@@ -138,5 +150,5 @@
         ONLY:  ind_pav_green, ind_veg_wall, ind_wat_win
 !
-!-- Define type for dimensions. 
+!-- Define type for dimensions.
     TYPE dims_xy
        INTEGER(iwp) :: nx                             !< dimension length in x
@@ -149,5 +161,5 @@
 !
 !-- Define data type for nesting in larger-scale models like COSMO.
-!-- Data type comprises u, v, w, pt, and q at lateral and top boundaries. 
+!-- Data type comprises u, v, w, pt, and q at lateral and top boundaries.
     TYPE force_type
 
@@ -206,8 +218,8 @@
     TYPE init_type
 
-       INTEGER(iwp) ::  lod_msoil !< level of detail - soil moisture 
+       INTEGER(iwp) ::  lod_msoil !< level of detail - soil moisture
        INTEGER(iwp) ::  lod_pt    !< level of detail - pt
        INTEGER(iwp) ::  lod_q     !< level of detail - q
-       INTEGER(iwp) ::  lod_tsoil !< level of detail - soil temperature 
+       INTEGER(iwp) ::  lod_tsoil !< level of detail - soil temperature
        INTEGER(iwp) ::  lod_u     !< level of detail - u-component
        INTEGER(iwp) ::  lod_v     !< level of detail - v-component
@@ -221,12 +233,12 @@
        INTEGER(iwp) ::  nzw       !< number of vertical levels on w grid in dynamic input file
 
-       LOGICAL ::  from_file_msoil  = .FALSE. !< flag indicating whether soil moisture is already initialized from file 
+       LOGICAL ::  from_file_msoil  = .FALSE. !< flag indicating whether soil moisture is already initialized from file
        LOGICAL ::  from_file_pt     = .FALSE. !< flag indicating whether pt is already initialized from file
-       LOGICAL ::  from_file_q      = .FALSE. !< flag indicating whether q is already initialized from file  
-       LOGICAL ::  from_file_tsoil  = .FALSE. !< flag indicating whether soil temperature is already initialized from file 
-       LOGICAL ::  from_file_u      = .FALSE. !< flag indicating whether u is already initialized from file 
-       LOGICAL ::  from_file_ug     = .FALSE. !< flag indicating whether ug is already initialized from file 
-       LOGICAL ::  from_file_v      = .FALSE. !< flag indicating whether v is already initialized from file 
-       LOGICAL ::  from_file_vg     = .FALSE. !< flag indicating whether ug is already initialized from file 
+       LOGICAL ::  from_file_q      = .FALSE. !< flag indicating whether q is already initialized from file
+       LOGICAL ::  from_file_tsoil  = .FALSE. !< flag indicating whether soil temperature is already initialized from file
+       LOGICAL ::  from_file_u      = .FALSE. !< flag indicating whether u is already initialized from file
+       LOGICAL ::  from_file_ug     = .FALSE. !< flag indicating whether ug is already initialized from file
+       LOGICAL ::  from_file_v      = .FALSE. !< flag indicating whether v is already initialized from file
+       LOGICAL ::  from_file_vg     = .FALSE. !< flag indicating whether ug is already initialized from file
        LOGICAL ::  from_file_w      = .FALSE. !< flag indicating whether w is already initialized from file
 
@@ -262,11 +274,11 @@
 
 !
-!-- Define data structures for different input data types. 
+!-- Define data structures for different input data types.
 !-- 8-bit Integer 2D
     TYPE int_2d_8bit
        INTEGER(KIND=1) ::  fill = -127                      !< fill value
        INTEGER(KIND=1), DIMENSION(:,:), ALLOCATABLE ::  var !< respective variable
-       
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
+
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
     END TYPE int_2d_8bit
 !
@@ -276,5 +288,5 @@
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  var  !< respective variable
 
-       LOGICAL ::  from_file = .FALSE. !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE. !< flag indicating whether an input variable is available and read from file or default values are used
     END TYPE int_2d_32bit
 
@@ -282,5 +294,5 @@
 !-- Define data type to read 2D real variables
     TYPE real_2d
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
 
        REAL(wp) ::  fill = -9999.9_wp                !< fill value
@@ -291,7 +303,7 @@
 !-- Define data type to read 2D real variables
     TYPE real_3d
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
-
-       INTEGER(iwp) ::  nz   !< number of grid points along vertical dimension                      
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
+
+       INTEGER(iwp) ::  nz   !< number of grid points along vertical dimension
 
        REAL(wp) ::  fill = -9999.9_wp                  !< fill value
@@ -299,9 +311,9 @@
     END TYPE real_3d
 !
-!-- Define data structure where the dimension and type of the input depends 
-!-- on the given level of detail. 
-!-- For buildings, the input is either 2D float, or 3d byte. 
+!-- Define data structure where the dimension and type of the input depends
+!-- on the given level of detail.
+!-- For buildings, the input is either 2D float, or 3d byte.
     TYPE build_in
-       INTEGER(iwp)    ::  lod = 1                               !< level of detail                  
+       INTEGER(iwp)    ::  lod = 1                               !< level of detail
        INTEGER(KIND=1) ::  fill2 = -127                          !< fill value for lod = 2
        INTEGER(iwp)    ::  nz                                    !< number of vertical layers in file
@@ -310,5 +322,5 @@
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  z                 !< vertical coordinate for 3D building, used for consistency check
 
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
 
        REAL(wp)                              ::  fill1 = -9999.9_wp !< fill values for lod = 1
@@ -317,12 +329,12 @@
 
 !
-!-- For soil_type, the input is either 2D or 3D one-byte integer. 
+!-- For soil_type, the input is either 2D or 3D one-byte integer.
     TYPE soil_in
-       INTEGER(iwp)                                   ::  lod = 1      !< level of detail                  
+       INTEGER(iwp)                                   ::  lod = 1      !< level of detail
        INTEGER(KIND=1)                                ::  fill = -127  !< fill value for lod = 2
        INTEGER(KIND=1), DIMENSION(:,:), ALLOCATABLE   ::  var_2d       !< 2d variable (lod = 1)
        INTEGER(KIND=1), DIMENSION(:,:,:), ALLOCATABLE ::  var_3d       !< 3d variable (lod = 2)
 
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
     END TYPE soil_in
 
@@ -333,5 +345,5 @@
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nfracs         !< dimension array for fraction
 
-       LOGICAL ::  from_file = .FALSE. !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE. !< flag indicating whether an input variable is available and read from file or default values are used
 
        REAL(wp)                                ::  fill = -9999.9_wp !< fill value
@@ -339,5 +351,5 @@
     END TYPE fracs
 !
-!-- Data type for parameter lists, Depending on the given level of detail, 
+!-- Data type for parameter lists, Depending on the given level of detail,
 !-- the input is 3D or 4D
     TYPE pars
@@ -345,8 +357,8 @@
        INTEGER(iwp)                            ::  np              !< total number of parameters
        INTEGER(iwp)                            ::  nz              !< vertical dimension - number of soil layers
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  layers          !< dimension array for soil layers 
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  layers          !< dimension array for soil layers
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  pars            !< dimension array for parameters
 
-       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used  
+       LOGICAL ::  from_file = .FALSE.  !< flag indicating whether an input variable is available and read from file or default values are used
 
        REAL(wp)                                  ::  fill = -9999.9_wp !< fill value
@@ -358,8 +370,8 @@
     TYPE(dims_xy)    ::  dim_static  !< data structure for x, y-dimension in static input file
 
-    TYPE(force_type) ::  force     !< data structure for data input at lateral and top boundaries (provided by Inifor)  
+    TYPE(force_type) ::  force     !< data structure for data input at lateral and top boundaries (provided by Inifor)
 
     TYPE(init_type) ::  init_3d    !< data structure for the initialization of the 3D flow and soil fields
-    TYPE(init_type) ::  init_model !< data structure for the initialization of the model 
+    TYPE(init_type) ::  init_model !< data structure for the initialization of the model
 
 !
@@ -511,5 +523,5 @@
 ! Description:
 ! ------------
-!> Inquires whether NetCDF input files according to Palm-input-data standard 
+!> Inquires whether NetCDF input files according to Palm-input-data standard
 !> exist. Moreover, basic checks are performed.
 !------------------------------------------------------------------------------!
@@ -531,10 +543,10 @@
 
 !
-!--    As long as topography can be input via ASCII format, no distinction 
+!--    As long as topography can be input via ASCII format, no distinction
 !--    between building and terrain can be made. This case, classify all
 !--    surfaces as default type. Same in case land-surface and urban-surface
 !--    model are not applied.
        IF ( .NOT. input_pids_static )  THEN
-          topo_no_distinct = .TRUE. 
+          topo_no_distinct = .TRUE.
        ENDIF
 
@@ -553,5 +565,5 @@
        INTEGER(iwp) ::  ii       !< running index for IO blocks
 
-       IF ( .NOT. input_pids_static )  RETURN  
+       IF ( .NOT. input_pids_static )  RETURN
 
        DO  ii = 0, io_blocks-1
@@ -579,8 +591,8 @@
        ENDDO
 !
-!--    In case of nested runs, each model domain might have different longitude 
-!--    and latitude, which would result in different Coriolis parameters and 
-!--    sun-zenith angles. To avoid this, longitude and latitude in each model 
-!--    domain will be set to the values of the root model. Please note, this 
+!--    In case of nested runs, each model domain might have different longitude
+!--    and latitude, which would result in different Coriolis parameters and
+!--    sun-zenith angles. To avoid this, longitude and latitude in each model
+!--    domain will be set to the values of the root model. Please note, this
 !--    synchronization is required already here.
 #if defined( __parallel )
@@ -647,7 +659,7 @@
                                      TRIM( coupling_char ) , id_surf )
 !
-!--             At first, inquire all variable names. 
+!--             At first, inquire all variable names.
 !--             This will be used to check whether an optional input variable
-!--             exist or not. 
+!--             exist or not.
                 CALL inquire_num_variables( id_surf, num_vars )
 
@@ -657,14 +669,14 @@
 !
 !--             Read leaf area density - resolved vegetation
-                IF ( check_existence( var_names, 'leaf_area_density' ) )  THEN
-                   leaf_area_density_f%from_file = .TRUE. 
+                IF ( check_existence( var_names, 'lad' ) )  THEN
+                   leaf_area_density_f%from_file = .TRUE.
                    CALL get_attribute( id_surf, char_fill,                     &
                                        leaf_area_density_f%fill,               &
-                                       .FALSE., 'leaf_area_density' )  
+                                       .FALSE., 'lad' )
 !
 !--                Inquire number of vertical vegetation layer
                    CALL get_dimension_length( id_surf, leaf_area_density_f%nz, &
                                               'zlad' )
-!            
+!
 !--                Allocate variable for leaf-area density
                    ALLOCATE( leaf_area_density_f%var(                          &
@@ -672,19 +684,19 @@
                                                    nys:nyn,nxl:nxr) )
 
-                   CALL get_variable( id_surf, 'leaf_area_density',      &
+                   CALL get_variable( id_surf, 'lad',      &
                                       nxl, nxr, nys, nyn,                &
                                       leaf_area_density_f%var(:,nys:nyn, nxl:nxr) )
 
                 ELSE
-                   leaf_area_density_f%from_file = .FALSE. 
+                   leaf_area_density_f%from_file = .FALSE.
                 ENDIF
 
 !
 !--             Read basal area density - resolved vegetation
-                IF ( check_existence( var_names, 'basal_area_density' ) )  THEN
-                   basal_area_density_f%from_file = .TRUE. 
+                IF ( check_existence( var_names, 'bad' ) )  THEN
+                   basal_area_density_f%from_file = .TRUE.
                    CALL get_attribute( id_surf, char_fill,                     &
                                        basal_area_density_f%fill,              &
-                                       .FALSE., 'basal_area_density' )  
+                                       .FALSE., 'bad' )
 !
 !--                Inquire number of vertical vegetation layer
@@ -692,5 +704,5 @@
                                               basal_area_density_f%nz,         &
                                               'zlad' )
-!            
+!
 !--                Allocate variable
                    ALLOCATE( basal_area_density_f%var(                         &
@@ -698,18 +710,18 @@
                                                   nys:nyn,nxl:nxr) )
 
-                   CALL get_variable( id_surf, 'basal_area_density',     &
+                   CALL get_variable( id_surf, 'bad',                    &
                                       nxl, nxr, nys, nyn,                &
                                       basal_area_density_f%var(:,nys:nyn, nxl:nxr) )
                 ELSE
-                   basal_area_density_f%from_file = .FALSE. 
+                   basal_area_density_f%from_file = .FALSE.
                 ENDIF
 
 !
 !--             Read root area density - resolved vegetation
-                IF ( check_existence( var_names, 'root_area_density_lad' ) )  THEN
-                   root_area_density_lad_f%from_file = .TRUE. 
+                IF ( check_existence( var_names, 'root_area_dens_r' ) )  THEN
+                   root_area_density_lad_f%from_file = .TRUE.
                    CALL get_attribute( id_surf, char_fill,                     &
                                        root_area_density_lad_f%fill,           &
-                                       .FALSE., 'root_area_density_lad' )  
+                                       .FALSE., 'root_area_dens_r' )
 !
 !--                Inquire number of vertical soil layers
@@ -717,5 +729,5 @@
                                               root_area_density_lad_f%nz,      &
                                               'zsoil' )
-!            
+!
 !--                Allocate variable
                    ALLOCATE( root_area_density_lad_f%var                       &
@@ -723,9 +735,9 @@
                                                 nys:nyn,nxl:nxr) )
 
-                   CALL get_variable( id_surf, 'root_area_density_lad',  &
-                                      nxl, nxr, nys, nyn,                              &
+                   CALL get_variable( id_surf, 'root_area_dens_r',  &
+                                      nxl, nxr, nys, nyn,           &
                                       root_area_density_lad_f%var(:,nys:nyn, nxl:nxr) )
                 ELSE
-                   root_area_density_lad_f%from_file = .FALSE. 
+                   root_area_density_lad_f%from_file = .FALSE.
                 ENDIF
 !
@@ -739,12 +751,12 @@
           ENDDO
 !
-!--       Deallocate variable list. Will be re-allocated in case further 
-!--       variables are read from file.          
+!--       Deallocate variable list. Will be re-allocated in case further
+!--       variables are read from file.
           IF ( ALLOCATED( var_names ) )  DEALLOCATE( var_names )
 
        ENDIF
 !
-!--    Skip the following if no land-surface or urban-surface module are 
-!--    applied. This case, no one of the following variables is used anyway.  
+!--    Skip the following if no land-surface or urban-surface module are
+!--    applied. This case, no one of the following variables is used anyway.
        IF (  .NOT. land_surface  .OR.  .NOT. urban_surface )  RETURN
 !
@@ -762,7 +774,7 @@
 
 !
-!--          Inquire all variable names. 
-!--          This will be used to check whether an optional input variable exist 
-!--          or not. 
+!--          Inquire all variable names.
+!--          This will be used to check whether an optional input variable exist
+!--          or not.
              CALL inquire_num_variables( id_surf, num_vars )
 
@@ -792,5 +804,5 @@
 !--          Read soil type and required attributes
              IF ( check_existence( var_names, 'soil_type' ) )  THEN
-                   soil_type_f%from_file = .TRUE. 
+                   soil_type_f%from_file = .TRUE.
 !
 !--             Note, lod is currently not on file; skip for the moment
@@ -800,5 +812,5 @@
                 CALL get_attribute( id_surf, char_fill,                        &
                                     soil_type_f%fill,                          &
-                                    .FALSE., 'soil_type' ) 
+                                    .FALSE., 'soil_type' )
 
                 IF ( soil_type_f%lod == 1 )  THEN
@@ -808,5 +820,5 @@
                    DO  i = nxl, nxr
                       CALL get_variable( id_surf, 'soil_type',                 &
-                                         i, soil_type_f%var_2d(:,i) ) 
+                                         i, soil_type_f%var_2d(:,i) )
                    ENDDO
                 ELSEIF ( soil_type_f%lod == 2 )  THEN
@@ -820,7 +832,7 @@
                       DO  j = nys, nyn
                          CALL get_variable( id_surf, 'soil_type', i, j,        &
-                                            soil_type_f%var_3d(:,j,i) )   
+                                            soil_type_f%var_3d(:,j,i) )
                       ENDDO
-                   ENDDO 
+                   ENDDO
                 ENDIF
              ELSE
@@ -831,8 +843,8 @@
 !--          Read pavement type and required attributes
              IF ( check_existence( var_names, 'pavement_type' ) )  THEN
-                pavement_type_f%from_file = .TRUE. 
+                pavement_type_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill,                        &
                                     pavement_type_f%fill, .FALSE.,             &
-                                    'pavement_type' )  
+                                    'pavement_type' )
 !
 !--             PE-wise reading of 2D pavement type.
@@ -840,5 +852,5 @@
                 DO  i = nxl, nxr
                    CALL get_variable( id_surf, 'pavement_type',                &
-                                      i, pavement_type_f%var(:,i) )  
+                                      i, pavement_type_f%var(:,i) )
                 ENDDO
              ELSE
@@ -849,5 +861,5 @@
 !--          Read water type and required attributes
              IF ( check_existence( var_names, 'water_type' ) )  THEN
-                water_type_f%from_file = .TRUE. 
+                water_type_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill, water_type_f%fill,     &
                                     .FALSE., 'water_type' )
@@ -857,5 +869,5 @@
                 DO  i = nxl, nxr
                    CALL get_variable( id_surf, 'water_type', i,                &
-                                      water_type_f%var(:,i) ) 
+                                      water_type_f%var(:,i) )
                 ENDDO
              ELSE
@@ -865,5 +877,5 @@
 !--          Read surface fractions and related information
              IF ( check_existence( var_names, 'surface_fraction' ) )  THEN
-                surface_fraction_f%from_file = .TRUE. 
+                surface_fraction_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill,                        &
                                     surface_fraction_f%fill,                   &
@@ -874,5 +886,5 @@
                                            surface_fraction_f%nf,              &
                                            'nsurface_fraction' )
-!            
+!
 !--             Allocate dimension array and input array for surface fractions
                 ALLOCATE( surface_fraction_f%nfracs(0:surface_fraction_f%nf-1) )
@@ -889,13 +901,13 @@
                                    surface_fraction_f%frac(:,nys:nyn, nxl:nxr))
              ELSE
-                surface_fraction_f%from_file = .FALSE. 
+                surface_fraction_f%from_file = .FALSE.
              ENDIF
 !
 !--          Read building parameters and related information
              IF ( check_existence( var_names, 'building_pars' ) )  THEN
-                building_pars_f%from_file = .TRUE. 
+                building_pars_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill,                        &
                                     building_pars_f%fill,                      &
-                                    .FALSE., 'building_pars' )  
+                                    .FALSE., 'building_pars' )
 !
 !--             Inquire number of building parameters
@@ -903,5 +915,5 @@
                                            building_pars_f%np,                 &
                                            'nbuilding_pars' )
-!            
+!
 !--             Allocate dimension array and input array for building parameters
                 ALLOCATE( building_pars_f%pars(0:building_pars_f%np-1) )
@@ -918,5 +930,5 @@
                                    building_pars_f%pars_xy(:,nys:nyn, nxl:nxr) )
              ELSE
-                building_pars_f%from_file = .FALSE. 
+                building_pars_f%from_file = .FALSE.
              ENDIF
 
@@ -924,7 +936,7 @@
 !--          Read albedo type and required attributes
              IF ( check_existence( var_names, 'albedo_type' ) )  THEN
-                albedo_type_f%from_file = .TRUE. 
+                albedo_type_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill, albedo_type_f%fill,    &
-                                    .FALSE.,  'albedo_type' ) 
+                                    .FALSE.,  'albedo_type' )
 !
 !--             PE-wise reading of 2D water type.
@@ -932,5 +944,5 @@
                 DO  i = nxl, nxr
                    CALL get_variable( id_surf, 'albedo_type',                  &
-                                      i, albedo_type_f%var(:,i) )  
+                                      i, albedo_type_f%var(:,i) )
                 ENDDO
              ELSE
@@ -940,12 +952,12 @@
 !--          Read albedo parameters and related information
              IF ( check_existence( var_names, 'albedo_pars' ) )  THEN
-                albedo_pars_f%from_file = .TRUE. 
+                albedo_pars_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill, albedo_pars_f%fill,    &
-                                    .FALSE., 'albedo_pars' )  
+                                    .FALSE., 'albedo_pars' )
 !
 !--             Inquire number of albedo parameters
                 CALL get_dimension_length( id_surf, albedo_pars_f%np,          &
                                            'nalbedo_pars' )
-!            
+!
 !--             Allocate dimension array and input array for albedo parameters
                 ALLOCATE( albedo_pars_f%pars(0:albedo_pars_f%np-1) )
@@ -959,9 +971,9 @@
                    DO  j = nys, nyn
                       CALL get_variable( id_surf, 'albedo_pars', i, j,         &
-                                         albedo_pars_f%pars_xy(:,j,i) )   
+                                         albedo_pars_f%pars_xy(:,j,i) )
                    ENDDO
                 ENDDO
              ELSE
-                albedo_pars_f%from_file = .FALSE. 
+                albedo_pars_f%from_file = .FALSE.
              ENDIF
 
@@ -969,13 +981,13 @@
 !--          Read pavement parameters and related information
              IF ( check_existence( var_names, 'pavement_pars' ) )  THEN
-                pavement_pars_f%from_file = .TRUE. 
+                pavement_pars_f%from_file = .TRUE.
                 CALL get_attribute( id_surf, char_fill,                        &
                                     pavement_pars_f%fill,                      &
-                                    .FALSE., 'pavement_pars' )  
+                                    .FALSE., 'pavement_pars' )
 !
 !--             Inquire number of pavement parameters
                 CALL get_dimension_length( id_surf, pavement_pars_f%np,        &
                                            'npavement_pars' )
-!            
+!
 !--             Allocate dimension array and input array for pavement parameters
                 ALLOCATE( pavement_pars_f%pars(0:pavement_pars_f%np-1) )
